org.apache.xml.dtm.ref

## Class DTMStringPool

- java.lang.Object
- - org.apache.xml.dtm.ref.DTMStringPool

Direct Known Subclasses:
  CustomStringPool, DTMSafeStringPool

    public class DTMStringPool
    extends java.lang.Object

DTMStringPool is an "interning" mechanism for strings. It will create a stable 1:1 mapping between a set of string values and a set of integer index values, so the integers can be used to reliably and uniquely identify (and when necessary retrieve) the strings.

Design Priorities:

- String-to-index lookup speed is critical.
- Index-to-String lookup speed is slightly less so.
- Threadsafety is not guaranteed at this level. Enforce that in the application if needed.
- Storage efficiency is an issue but not a huge one. It is expected that string pools won't exceed about 2000 entries.

Implementation detail: A standard Hashtable is relatively inefficient when looking up primitive int values, especially when we're already maintaining an int-to-string vector. So I'm maintaining a simple hash chain within this class.

NOTE: There is nothing in the code that has a real dependency upon String. It would work with any object type that implements reliable .hashCode() and .equals() operations. The API enforces Strings because it's safer that way, but this could trivially be turned into a general ObjectPool if one was needed.

Status: Passed basic test in main().

### Field Summary

Fields
`static int` `NULL`

### Constructor Summary

Constructors
Constructor and Description
`DTMStringPool()`
`DTMStringPool(int chainSize)` Create a DTMStringPool using the given chain size

### Method Summary

Methods
`java.lang.String` `indexToString(int i)`
`static void` `main(java.lang.String[] args)` Command-line unit test driver.
`void` `removeAllElements()`
`int` `stringToIndex(java.lang.String s)`

### Methods inherited from class java.lang.Object

`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### NULL

    public static final int NULL

See Also:
  Constant Field Values

### Constructor Detail

#### DTMStringPool

    public DTMStringPool(int chainSize)

Create a DTMStringPool using the given chain size

Parameters:
  `chainSize` - The size of the hash chain vector

#### DTMStringPool

    public DTMStringPool()

### Method Detail

#### removeAllElements

    public void removeAllElements()

#### indexToString

    public java.lang.String indexToString(int i)
                                   throws java.lang.ArrayIndexOutOfBoundsException

Returns:
  string whose value is uniquely identified by this integer index.
Throws:
  `java.lang.ArrayIndexOutOfBoundsException` - if index doesn't map to a string.

#### stringToIndex

    public int stringToIndex(java.lang.String s)

Returns:
  integer index uniquely identifying the value of this string.

#### main

    public static void main(java.lang.String[] args)

Command-line unit test driver. This test relies on the fact that this version of the pool assigns indices consecutively, starting from zero, as new unique strings are encountered.